# /usr/sbin/apsx with httpd < 2.4 and defined as /usr/bin/apxs with httpd >= 2.4
%{!?_httpd_apxs:       %{expand: %%global _httpd_apxs       %%{_sbindir}/apxs}}
%{!?_httpd_mmn:        %{expand: %%global _httpd_mmn        %%(cat %{_includedir}/httpd/.mmn 2>/dev/null || echo 0-0)}}
%{!?_httpd_confdir:    %{expand: %%global _httpd_confdir    %%{_sysconfdir}/httpd/conf.d}}
# /etc/httpd/conf.d with httpd < 2.4 and defined as /etc/httpd/conf.modules.d with httpd >= 2.4
%{!?_httpd_modconfdir: %{expand: %%global _httpd_modconfdir %%{_sysconfdir}/httpd/conf.d}}
%{!?_httpd_moddir:     %{expand: %%global _httpd_moddir     %%{_libdir}/httpd/modules}}

Summary: An apache2 module for executing PHP scripts with the permissions of their owners
Name: mod_suphp
Version: 0.7.2
Release: 1%{?dist}
License: GPL/Apache License
Group: System Environment/Daemons
Source0: http://www.suphp.org/download/suphp-%{version}.tar.gz
Source1: suphp.conf
Source2: mod_suphp.conf
Source3: README.txt
Patch0: mod_suphp-0.7.2-userdir.patch
Patch3: mod_suphp-0.7.2-chroot.patch
URL: http://www.suphp.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: httpd >= 2.0, php
Requires: httpd-mmn = %{_httpd_mmn}
BuildRequires: httpd-devel >= 2.0, apr-devel, gcc-c++, automake, autoconf, libtool

%description
suPHP is a tool for executing PHP scripts with the permissions of their owners.
It consists of an Apache module (mod_suphp) and a setuid root binary (suphp)
that is called by the Apache module to change the uid of the process executing
the PHP interpreter.

%prep
%setup -q -n suphp-%{version}
%patch0 -p 1 -b .userdir
%patch3 -p 1 -b .chroot

cat %{SOURCE3} > README.txt

%build
sed -i 's/AM_CONFIG_HEADER/AC_CONFIG_HEADERS/g' configure.ac
%if 0%{?rhel} > 6
sed -i 's#"\$major_version" = "2.2"#"\$major_version" = "2.4"#g' configure
%endif
aclocal
libtoolize --force
automake --add-missing
autoreconf
%configure \
    --with-apr=%{_bindir}/apr-1-config \
    --with-apxs=%{_httpd_apxs} \
    --with-apache-user=apache \
    --with-min-uid=500 \
    --with-min-gid=500 \
    --with-logfile="%{_localstatedir}/log/httpd/suphp_log" \
    --with-setid-mode=owner 

pushd src
make %{?_smp_mflags} suphp
popd

pushd src/apache2
%{_httpd_apxs} -c mod_suphp.c
mv .libs/mod_suphp.so .
popd

%install
rm -rf %{buildroot}

%{__install} -c -m 4755 -D src/suphp %{buildroot}%{_sbindir}/suphp
%{__install} -m 755 -D src/apache2/mod_suphp.so %{buildroot}%{_httpd_moddir}/mod_suphp.so

# Install the config files
%{__install} -m 644 -D %{SOURCE1} %{buildroot}%{_sysconfdir}/suphp.conf

# httpd <= 2.2.x
%if "%{_httpd_confdir}" == "%{_httpd_modconfdir}"
%{__install} -dm 0755 %{buildroot}%{_httpd_confdir}
%{__install} -m 644 -D %{SOURCE2} %{buildroot}%{_httpd_confdir}/mod_suphp.conf
%else
# httpd >= 2.4.x
%{__install} -dm 0755 %{buildroot}%{_httpd_modconfdir}
%{__install} -m 644 -D %{SOURCE2} %{buildroot}%{_httpd_modconfdir}/10-mod_suphp.conf
%endif

# Rename docs
cp doc/apache/CONFIG CONFIG.apache
mv doc/* .

%clean
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/suphp-%{version}

%files
%defattr(-,root,root)
%doc AUTHORS ChangeLog COPYING README* CONFIG* INSTALL LICENSE apache/ suphp.conf*
%attr (4550, root, apache) %{_sbindir}/suphp
%{_httpd_moddir}/%{name}.so
%config(noreplace) %{_sysconfdir}/suphp.conf
# httpd <= 2.2.x
%if "%{_httpd_confdir}" == "%{_httpd_modconfdir}"
%config(noreplace) %{_httpd_confdir}/mod_suphp.conf
%else
# httpd >= 2.4.x
%config(noreplace) %{_httpd_modconfdir}/10-mod_suphp.conf
%endif

%changelog
* Fri Aug 15 2015 Claudio Borges <cbsfilho@gmail.com> - 0.7.2-1
- Initial release
